const PREF_SVC = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService);
const PREF_OBJ   = PREF_SVC.getBranch("");


function isInt(x) { 
   var y=parseInt(x); 
   if (isNaN(y)) return false; 
   return x==y && x.toString()==y.toString(); 
 } 
 
function ChangeMessage()
{
	var message = document.getElementById("Message").value;
	var length = message.length;

	if(length>160) m = 153;
	else m = 160;

	var n = Math.floor(length/m);
	if( isInt(length/m) && n > 0) n = n-1;
	
	if( length > 160 ) document.getElementById("lblCounter").value = message.length + ' (' + (n + 1) + ' SMS)';
	else document.getElementById("lblCounter").value = message.length;
}

function SendSMS()
{
	var recipient = document.getElementById("Recipient");
	var sender = document.getElementById("Sender");
	var message = document.getElementById("Message");
	
	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	
	var request = "&login=" + ConvertTermsToURI(login) + "&password=" + ConvertTermsToURI(password) + "&number=" + ConvertTermsToURI(recipient.value) + "&message=" + ConvertTermsToURI(message.value) + "&expediteur=" + ConvertTermsToURI(sender.value) + "&type=7"; 

	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET', "http://www.envoyersms.biz/api/v1/?method=send" + request, false);
	xmlhttp.send('');
	Alert(xmlhttp.responseText);
	
	var sms = getSMS();
	
	document.getElementById('Solde-Button').label = ((sms >= 0) ? sms : 0) + " SMS restant" + ((sms > 1) ? 's' : '');	
	if(xmlhttp.responseText == 'OK' )
	{
		document.getElementById('Recipient').value = "06";
		message.value = "";
		document.getElementById("lblCounter").value = 0;
	}
}

function ConvertTermsToURI(terms)
{
    var termArray = new Array();
    termArray = terms.split(' ');

    var result = '';
    for(var i=0; i<termArray.length; i++)
    {
        if(i > 0) result += '+';
        result += escape(termArray[i]);
    }
    return result;
}

function LoadParams()
{
	if (!PREF_OBJ.prefHasUserValue('envoyersms.login')){
		PREF_OBJ.setCharPref('envoyersms.login', '');
		PREF_OBJ.setCharPref('envoyersms.password', '');
	}

	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	
	var xmlhttp = new XMLHttpRequest();
	xmlhttp.open('GET', "http://www.envoyersms.biz/api/v1/toolbar.php?action=expediteur&login=" + ConvertTermsToURI(login) + "&password=" + ConvertTermsToURI(password), false);
	xmlhttp.send('');
	
	if (xmlhttp.responseText!='ERR_01')	document.getElementById('Sender').value = xmlhttp.responseText;
	else document.getElementById('Sender').value = '';
	
	var sms = getSMS();
	document.getElementById('Solde-Button').label = ((sms >= 0) ? sms : 0) + " SMS restant" + ((sms > 1) ? 's' : '');
}

function LoadContactsList()
{
    var menu = document.getElementById('ContactsList');
    for(var i=menu.childNodes.length - 1; i >= 0; i--){
        menu.removeChild(menu.childNodes.item(i));
    }
	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	
    var xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', "http://www.envoyersms.biz/api/v1/toolbar.php?action=contacts&login=" + ConvertTermsToURI(login) + "&password=" + ConvertTermsToURI(password) , false);
    xmlhttp.send('');
    if (xmlhttp.responseText!='ERR_01')
	{
		var contacts = eval( "(" + xmlhttp.responseText + ")" );
	    for (var i=0;i<contacts.length;i++)
		{
            var tempItem = document.createElement('menuitem');
            tempItem.setAttribute('label', contacts[i]['nom']);
            tempItem.setAttribute('oncommand', "ChangeNumber('" + contacts[i]['numero'] + "')");
            menu.appendChild(tempItem);
        }
    }
}

function ChangeNumber(number)
{
	var Edt_Dest = document.getElementById('Recipient');
	Edt_Dest.value=number;
	var menu = document.getElementById('ContactsList');
	menu.selectedIndex=-1;
	Edt_Dest.focus();
}

function Alert(error)
{
	var url='chrome://envoyersms/content/alert.xul?msg='+error;
	WindowObjectReference = window.open(url,'Dialog_Window','chrome,modal=yes,menubar=no,location=no,resizable=no,scrollbars=no,status=no,centerscreen=yes');
	WindowObjectReference.sizeToContent();
	window.content.focus();
}

function LoadOptionsForm()
{
	window.openDialog("chrome://envoyersms/content/options/options.xul", "envoyersms-options-dialog","centerscreen,chrome,modal,resizable");
}

function BuyPage()
{
	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	var request = '';
	if(login != '') request = "login.php?redirect=recharger&login=" + ConvertTermsToURI(login) + "&password=" + ConvertTermsToURI(password);
	else request = 'recharger.php';
	GoURL("http://www.envoyersms.biz/" + request);
}

function Homepage()
{
	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	var request = '';
	if(login != '') request = "login.php?login=" + ConvertTermsToURI(login) + "&password=" + ConvertTermsToURI(password);
	GoURL("http://www.envoyersms.biz/" + request);
}

function GoURL(url)
{
    window._content.document.location = url;
    window.content.focus();
}

function getSMS()
{
	var login=PREF_OBJ.getCharPref('envoyersms.login');
	var password=decode(PREF_OBJ.getCharPref('envoyersms.password'));
	
	var xmlhttp = new XMLHttpRequest();
    xmlhttp.open('GET', "http://www.envoyersms.biz/api/v1/toolbar.php?action=credit&login=" + ConvertTermsToURI(login) +"&password=" + ConvertTermsToURI(password), false);
    xmlhttp.send('');
    if (xmlhttp.responseText != 'ERR_01')
	{
		return (isNaN(parseInt(xmlhttp.responseText)) ? 0 : parseInt(xmlhttp.responseText));
	}
	return -1;
}